<template>
  <div>
    <el-form-item label="Repo-Url:" prop="repo_url">
      <el-input v-model="model.repo_url" disabled></el-input>
    </el-form-item>
    <el-form-item label="Repo-Name:" prop="repo_name">
      <el-input v-model="model.repo_name" disabled></el-input>
    </el-form-item>
    <el-form-item label="Repo-Id: " prop="repo_id">
      <el-input v-model="model.repo_id" disabled></el-input>
    </el-form-item>
    <el-form-item label="No. of Approvers: " prop="no_of_approvers">
      <el-input v-model.number="model.no_of_approvers"></el-input>
    </el-form-item>
    <el-row :gutter="20">
      <el-col :span="18">
        <el-form-item label="Search for Username: " prop="approvers">
          <el-select
            v-model="value"
            type="textarea"
            multiple
            filterable
            remote
            :remote-method="remoteMethod"
            :disabled="!model.repo_url"
          >
            <el-option
              v-for="item in options"
              :key="item.id"
              :label="item.name"
              :value="item.username"
              :loading="loading"
            />
          </el-select>
        </el-form-item>
      </el-col>

      <el-form-item>
        <el-button type="primary" @click="addApproversIdToFormData"
          >Add</el-button
        >
      </el-form-item>
    </el-row>
    <el-form-item label="Already added Approvers">
      <el-tag
        v-for="tag in tags"
        :key="tag.index"
        closable
        @close="handleClose(tag)"
      >
        {{ tag.approvers_approvers_id.email || tag.approvers_approvers_id }}
      </el-tag>
    </el-form-item>
    <el-row :gutter="20">
      <el-col :span="20">
        <el-form-item label="Add Developer to Repo: " prop="approvers">
          <el-select
            v-model="project_model.devtobeadded"
            type="textarea"
            multiple
            filterable
            remote
            :disabled="addDevBool"
            :remote-method="remoteMethodDev"
            :loading="loading"
          >
            <el-option
              v-for="item in devoptions"
              :key="item.id"
              :label="item.name"
              :value="item.id"
            />
          </el-select>
        </el-form-item>
      </el-col>
      <el-form-item>
        <el-button type="primary" @click="addDevloper" :disabled="addDevBool"
          >Add</el-button
        >
      </el-form-item>
    </el-row>
    <!-- {{model}} -->
    <!-- {{tags}} -->
  </div>
</template>
<script>
// import { mapState } from "vuex";
export default {
  props: ["data", "apiParams"],
  data() {
    return {
      project_model: {
        gitlab_url: "",
        devtobeadded: [],
        project_id: undefined,
      },
      devoptions: [],
      addDevBool: false,
      loading: false,
      tags: [],
      options: [],
      value: [],
      model: {},
    };
  },
  mounted() {
    this.model = JSON.parse(JSON.stringify(this.data));
    this.tags = this.model.approvers;
    this.project_model.project_id = this.model.repo_id
    let fullUrl = new URL(this.model.repo_url);
    let baseurl = fullUrl.origin;
    this.project_model.gitlab_url = baseurl
  },
  computed: {
    rules() {
      return {
        no_of_approvers: [
          {
            required: true,
            message: "Please input no of approvers",
            trigger: "change",
          },
          { type: "number", message: "No of approvers must be a number" },
        ],
      };
    },
  },
  methods: {
    handleClose(tag) {
      this.model.approvers.splice(this.model.approvers.indexOf(tag), 1);
    },
    remoteMethod(query) {
      let fullurl = new URL(this.model.repo_url);
      let baseurl = fullurl.origin;
      // console.log(baseurl)
      if (query !== "") {
        this.loading = true;
        const config = {
          method: "post",
          url: "/search-user",
          data: {
            requrl: baseurl,
            query: query,
          },
        };
        this.$axios(config)
          .then((res) => {
            this.options = res.data;
            this.loading = false;
          })
          .catch((err) => {
            console.log(err);
          });
      }
    },
    remoteMethodDev(query) {
      let baseurl = this.project_model.gitlab_url;
      // console.log(baseurl)
      if (query !== "") {
        this.loading = true;
        const config = {
          method: "post",
          url: '/search-user',
          data: {
            requrl: baseurl,
            query: query,
          },
        };
        this.$axios(config)
          .then((res) => {
            this.devoptions = res.data;
            this.loading = false;
          })
          .catch((err) => {
            console.log(err);
          });
      }
    },
    addDevloper() {
      this.$store.dispatch("addDevloper", this.project_model);
      this.addDevBool = true;
    },
    addApproversIdToFormData() {
      let newarr = this.model.approvers;
      this.value.forEach(async (approver) => {
        let payload = {
          url: `items/approvers?&filter[email]=${approver}`,
        };
        await this.$store.dispatch("getField", payload).then((resdata) => {
          if (resdata.length > 0 && resdata[0].email == approver) {
            // console.log("res data here in if", resdata);
            let obj = {};
            obj["approvers_approvers_id"] = resdata[0].approvers_id;
            // console.log("obj", obj);
            newarr.push(obj);
          } else {
            // console.log("im in else", resdata);
            let obj = {};
            obj["email"] = approver;
            let finalobj = {};
            finalobj["approvers_approvers_id"] = obj;
            newarr.push(finalobj);
          }
        });
        this.model.approvers = newarr;
        this.value = [];
      });
    },
    postData() {
      this.apiParams["data"] = this.model;
      return this.$store.dispatch("editTableData", this.apiParams);
    },
  },
};
</script>